<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Questionario extends CrudWithParameterBag{
    
    const TABLE = 'QUESTIONARIO';
    const NRQUESTIONARIO = 'NRQUESTIONARIO';
    protected $dataSourceName = 'questionario';
    protected $parameterBagColumns = array('NRORG','NRQUESTIONARIO');
    protected $novoCodigo;
    protected $dataSourceManager;
    protected $parameterBag;
    protected $util;
     
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, $novoCodigo, $util) {
        $this->novoCodigo  = $novoCodigo;
        $this->util = $util;
        parent::__construct($dataSourceManager, $parameterBag);
    }
    
    public function delete(DTO\Request\DataSet $request, DTO\Response $response){
        self::deleteWithoutNotification($request,$response);
    }
    
    public function save (DTO\Request\DataSet $request, DTO\Response $response){
        $row = $this->util->getParamsAsArray($request);
        if(count($row)){
            self::saveWithoutNotification($this->setCodigo($request,$row),$response);
        }
    }
    
    private function setCodigo ($request, $rows){
        foreach ($rows as $key => $row) {
            if($row['__is_new']){
                $novoCodigo = $this->novoCodigo->getCodeByTableName(self::TABLE,$row['NRORG'],1,null,false);
                $request->getDataSet()->getRows()[$key]->set(self::NRQUESTIONARIO, $novoCodigo);
            }
        }
        return $request;
    }
    
    public function saveWithoutNotification(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            $nrPersistedRows = count($persistedRows);
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    public function deleteWithoutNotification(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->dataSourceManager->delete($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $deletedRows));
            $nrDeletedRows = count($deletedRows);
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}